;	page 0
	device zxspectrum128
        ORG #6000
begin
fnt:incbin "bdead.fnt"
runi:
	ld a,$10,bc,$7ffd:out (c),a
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr
	ld hl,$5800,de,$5801,bc,767,(hl),$47:ldir

;roll font
	ld hl,fnt
rf:
	push hl
	ld b,8
rf1:
	ld a,(hl)
	srl a
	srl a
	srl a
	srl a
	or (hl)
	ld (hl),a
	inc h
	djnz rf1
	pop hl
	inc l
	jr nz,rf

;	jr $
linea equ $F800 ;adresses of lines
;zero adr
	ld hl,linea
	xor a
zm:
	ld (hl),a
	inc hl
	cp h
	jp nz,zm
;count lines
	ld ix,txt
	ld hl,linea
	ld bc,0
cl:
;	ld a,(ix+0)
;	or a:jp z,ex_count
;if $0D0A, put to address
	inc bc
	push ix
	pop de
	ld (hl),e:inc hl
	ld (hl),d:inc hl

cl2:
	ld a,(ix+0)
	or a:jp z,ex_count
	cp $0D:jr nz,next
	ld a,(ix+1):cp $0A:jr nz,next
	inc ix,ix
	jp cl
next:
	inc ix
	jr cl2
ex_count:
	ld (lc),bc

;	jr $
;scroll
;	ld ix,linea;+2*(854-24)
	ld hl,(cc)
	ld bc,linea
	add hl,hl
	add hl,bc
	push hl
	pop ix
;	ld bc,48
;	or a:sbc hl,bc
;	push hl
;	pop ix

	ld a,23
sb:
	push af
	ld e,(ix):inc ix
	ld d,(ix):inc ix
	ld hl,$50E0
	call pr
;	jr $

	call sup

;zero line
	ld hl,$50E0
	call zero_line

	pop af
	dec a
	jp nz,sb

	ld e,(ix):inc ix
	ld d,(ix):inc ix
	ld hl,$50E0
	call pr

;keyloop
keyl:
	ld a,$FB:in a,($FE):and #1:jp z,downk ;Q - up
	ld a,$FD:in a,($FE):and #1:jp z,upk; A - down
;page++
	ld a,$DF:in a,($FE):and #2:jp z,pagem;O pagem
	ld a,$DF:in a,($FE):and #1:jp z,pagep;P pagep
	jr keyl
pagep:
;	jr $
	ld hl,(cc)
	ld bc,24
	add hl,bc
	ld de,(lc)
	or a
	sbc hl,de
	jp z,keyl
	jp nc,keyl
	add hl,de
print_all:
	ld (cc),hl
	add hl,hl
	ld bc,linea
	add hl,bc
	push hl
	pop ix
	ld hl,$4000,de,$4001,bc,6143,(hl),l:ldir
	ld hl,$4000
	exx
	ld de,(cc)
	exx
;whole text
pt:
	ld e,(ix+0):inc ix
	ld d,(ix+0):inc ix
;	ld a,d
;	or e
;	jp z,keyl

	push hl
	call pr
	exx
	inc de
	ld hl,(lc)
	dec hl
	or a
	sbc hl,de
	exx
	pop hl
	jp c,keyl
	ld a,l
	add a,32
	ld l,a
	sbc a,a
	and 8
	add a,h
	ld h,a
	cp $58
	jp nz,pt
	jp keyl
pagem:
;	jr $
	ld hl,(cc)
	ld a,h:or l:jp z,keyl
	ld bc,24
	or a
	sbc hl,bc
	jr nc,nobottom
	ld hl,0
nobottom:
	jp print_all

downk:
;	jr $
	ld hl,(cc)
	ld a,h:or l:jp z,keyl
	dec hl
	ld (cc),hl
	push hl
	
;scroll down
	ld hl,$57C0
	ld de,$57E0
	ld a,192-8
scd:
	exa
	push de,hl
 dup 32
	ldi
edup 
	pop hl,de
	call up_hl,up_de
	exa
	dec a
	jp nz, scd

	ld hl,$4000
	call zero_line

	pop hl
	ld bc,linea
	add hl,hl
	add hl,bc
	ld e,(hl):inc hl
	ld d,(hl):inc hl
	ld hl,$4000
	call pr

	jp keyl;jr $
upk:
;	jr $
	ld hl,(cc)
	ld bc,24
	add hl,bc
	ld bc,(lc)
	or a
	sbc hl,bc
	jp z,keyl
	jp nc,keyl

	add hl,bc

	ld bc,linea
	add hl,hl
	add hl,bc

	push hl
	call sup
	ld hl,$50E0
	call zero_line

	ld bc,(cc)
	inc bc
	ld (cc),bc
	
	pop hl
	ld e,(hl):inc hl
	ld d,(hl):inc hl
	ld hl,$50E0
	call pr
	jp keyl;jr $
;ltest sup
;	ld a,23
;tsu:
;	push af
;	call sup
;	pop af
;	dec a
;	jr nz,tsu
;	jr $
sup:
;scroll up
	ld de,$4000
	ld hl,$4020
	ld a,192-8
su:
	exa
	push de,hl
 dup 32
 ldi
edup
	pop hl,de
	call nbde,nbhl
	exa
	dec a
	jr nz,su
	ret


zero_line:
	ld c,8
zl:
	xor a
	ld b,32
	push hl
zl2:
	ld (hl),a
	inc l
	djnz zl2
	pop hl
	inc h
	dec c
	jr nz,zl
	ret

pr:
;	ld a,d:or e:ret z
pr2:
	ld b,fnt/256
	ld a,(de)
	cp $0D
	ret z
	ld c,a
	push hl
 dup 8
 	ld a,(bc)
 	and $F0
 	ld (hl),a
 	inc h,b
edup
	pop hl
	inc de
	ld a,(de)
	cp $0D
	ret z
	ld c,a
	ld b,fnt/256

	push hl
 dup 8
 	ld a,(bc)
 	and $0F
 	or (hl)
 	ld (hl),a
 	inc h,b
edup
	pop hl
	inc de
	inc l
	ld a,l
	and 31
	jp nz,pr2
	ret
lc: dw 0 ;line count
cc: dw 0 ; current count
nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET
nbhl    INC h:LD A,h:AND 7:RET NZ
        LD A,L:ADD A,#20:LD L,A:RET C
        LD A,H:SUB 8:LD H,A:RET
up_hl:
     LD A,H
     DEC H
     AND 7
     ret nz
     LD A,L
     SUB 32
     LD L,A
     ret c
     LD A,H
     ADD A,8
     LD H,A
 ret

up_de:
     LD A,D
     DEC D
     AND 7
     ret nz
     LD A,E
     SUB 32
     LD E,A
     ret c
     LD A,D
     ADD A,8
     LD D,A
 ret
	page 0
	org $
txt:incbin "zeus_win.txt"
 db 0
end
	display /d,end-begin
	savesna "!void.sna",runi;begin
	savebin "zeushelp.bin",begin,end-begin
